package UDP::Model;

use Moose;

has 'submodels' => ( is => 'rw', isa => 'ArrayRef' );

sub get_submodels {
    my ($self) = @_;
    return @{$self->submodels};
}

sub compute_counts_and_logprob {
    my ($self, $type, $node, $diff_counts, $diff_logprob, $counts) = @_;
    foreach my $submodel ($self->get_submodels) {
        $submodel->compute_counts_and_logprob($type, $node, $diff_counts, $diff_logprob, $counts);
    }
}

1;

