package UDP::Model::Edge;

use Moose;

has 'alpha' => ( is => 'rw', isa => 'Num', default => 1 );
has 'classes' => ( is => 'rw', isa => 'Int', default => 100 );

sub compute_counts_and_logprob {
    my ($self, $type, $node, $diff_count, $diff_logprob, $count) = @_;
    my $parent = $node->parent;
    my $direction = $node->ord < $parent->ord ? 'L' : 'R';
    my $edge_label = "edge ".$node->tag." ".$parent->tag." ".$direction;
    my $parent_label = "parent ".$parent->tag;
    if ($type eq 'del') {
        $diff_count->{$edge_label}--;
        $diff_count->{$parent_label}--;
#print STDERR "deleting $edge_label ".$node->ord." ".$parent->ord." ".($count->{$edge_label}||0)." ".($diff_count->{$edge_label}||0)."\n";
        $$diff_logprob -= log(($count->{$edge_label} || 0) + ($diff_count->{$edge_label} || 0) + $self->alpha);
        $$diff_logprob += log(($count->{$parent_label} || 0) + ($diff_count->{$parent_label} || 0) + $self->alpha * $self->classes);
    }
    elsif ($type eq 'ins') {
#print STDERR "inserting";        
        $$diff_logprob += log(($count->{$edge_label} || 0) + ($diff_count->{$edge_label} || 0) + $self->alpha);
        $$diff_logprob -= log(($count->{$parent_label} || 0) + ($diff_count->{$parent_label} || 0) + $self->alpha * $self->classes);
        $diff_count->{$edge_label}++;
        $diff_count->{$parent_label}++;
#print STDERR " $edge_label ".$node->ord." ".$parent->ord." ".($count->{$edge_label}||0)." ".($diff_count->{$edge_label}||0)."\n";
    }
}

1;

