package UDP::Sentence;

use Moose;

has 'nodes' => ( is => 'rw', isa => 'ArrayRef' );
has 'root'  => ( is => 'rw', isa => 'UDP::Node', default => sub { UDP::Node->new({tag => '<root>', form => '<root>', ord => 0, leftmost => 0, rightmost => 0 }) } );

sub get_nodes {
    my ($self) = @_;
    return (@{$self->nodes});
}

sub initialize {
    my ($self, $use_aux) = @_;
    my @nodes = $self->get_nodes;
    my $head = $nodes[int(rand(scalar @nodes))];
    $head->parent($self->root);
    $head->is_aux(0);
    my @children = grep {$_ ne $head} @nodes;
    $head->set_children(\@children);
    foreach my $node (@children) {
        $node->parent($head);
        $node->is_aux(1) if $use_aux && rand() < 0.25;
        
    }
    $self->root->set_children([$head]);
}

1;

