#!/usr/bin/perl

use strict;
use warnings;

binmode STDIN, ":utf8";
binmode STDOUT, ":utf8";

my @token;
while (<>) {
    chomp;
    if (/^\s*$/) {
        # nothing can depend on punctuation
        foreach my $i (1 .. $#token) {
            while ($token[$i][6] != 0 && is_punctuation($token[$token[$i][6]][1])) {
                $token[$i][6] = $token[$token[$i][6]][6];
            }
        }
        # get mapping
        my @mapping = (0);
        my $counter = 0;
        foreach my $i (1 .. $#token) {
            if (!is_punctuation($token[$i][1])) {
                $counter++;
            }
            push @mapping, $counter;
        }
        # remove punctuation
        foreach my $i (1 .. $#token) {
            if (!is_punctuation($token[$i][1])) {
                $token[$i][0] = $mapping[$token[$i][0]];
                $token[$i][6] = $mapping[$token[$i][6]];
                print join("\t", @{$token[$i]}) . "\n";
            }
        }
        print "\n" if $counter;
        @token = ();
    }
    else {
        my @items = split /\t/;
        $token[$items[0]] = \@items;
    }
}

sub is_punctuation {
    my $form = shift;
    return 1 if ($form !~ /^[\w\d]/ || $form =~ /^_/);
    return 0;
}
